/*-------------------------------------------------------------+
|   UI_code.cpp                                                |
+-------------------------------------------------------------*/
#include <Mstn\MdlApi\MdlApi.h>
#include <DgnPlatform\DgnPlatformApi.h>
#include <DgnView\DgnElementSetTool.h>
#include <Mstn\ISessionMgr.h>
#include <Bentley\BentleyAllocator.h>
#include <DgnPlatform\LevelCache.h>
#include <DgnPlatform\NotificationManager.h>
#include "UI_codeCmd.h"
#include "UI_code.h"


USING_NAMESPACE_BENTLEY_MSTNPLATFORM
USING_NAMESPACE_BENTLEY_DGNPLATFORM
USING_NAMESPACE_BENTLEY_MSTNPLATFORM
USING_NAMESPACE_BENTLEY_MSTNPLATFORM_ELEMENT


UI_CodeInfo  g_uicode;//һUI_CodeInfo͵ı ûϢ
bool         g_firstStart = true;

void updateDialog(ElementHandleR eh, MSDialogP dbP , DialogItem  *diP)//
{
	if (NULL == diP)
		return;
	ViewFlags viewflags;
	mdlView_getDefaultFlags(&viewflags);
	viewflags.camera = 0;
	//viewflags.renderMode = (UInt32)MSRenderMode::SmoothShade;
	RotMatrix rMatrix;
	mdlView_getStandard(&rMatrix, StandardView::Top);
	DRange3d  range;
	Dpoint3d  extent;
	mdlElement_extractRange(&range, eh.GetElementCP());
	extent.Subtract(range.high, (DVec3dR)range.low);
	mdlElmdscr_extendedDisplayToWindow((MSWindowP)dbP, &diP->GetRect(), &viewflags, eh.GetElementDescrCP(),
		                               &rMatrix, &range.low, &extent, true, -1, NULL, true, NULL);
}
void YuLanElement(	DialogItemMessage       *dimP  )//Ԥť
{
	if(dimP->messageType == DITEM_MESSAGE_BUTTON && BUTTONTRANS_UP==dimP->u.button.buttonTrans)   //ťʱյDITEM_MESSAGE_BUTTONϢ
																						 //һ갴ť£һ̧Ϊ˱´뱻ִΣж
																						 //BUTTONTRANS_UP==dimP->u.button.buttonTrans갴ţ̌ʱִ´
	{
		DialogItem* ppp=mdlDialog_itemGetByTypeAndId(dimP->db,RTYPE_Generic ,GENERICID_Cells , 0 );
		EditElementHandle eehBUT;
		CurveVectorPtr pCurveVec1 = CurveVector::Create(CurveVector::BOUNDARY_TYPE_Outer);
		pCurveVec1->Add(ICurvePrimitive::CreateRectangle(100-100/2,100-100/2,100+100/2,100+100/2,0) );
		DVec3d extrusionVec1 = DVec3d::From(0, 0, 50 );
		DgnExtrusionDetail data1(pCurveVec1, extrusionVec1, true);//pCurveVec
		ISolidPrimitivePtr pSolid1 = ISolidPrimitive::CreateDgnExtrusion(data1);
		DraftingElementSchema::ToElement(eehBUT, *pSolid1, nullptr, *ACTIVEMODEL);
		updateDialog(eehBUT, dimP->db , ppp);
		
		g_firstStart = false;
	}
	return;
}
void DlgBasic_hookFunc (DialogMessage *dmP)  //ԻӺ
{
	dmP->msgUnderstood = TRUE;
    switch (dmP->messageType)
        {
        case DIALOG_MESSAGE_CREATE:
            {
            dmP->u.create.interests.windowMoving= TRUE;
            dmP->u.create.interests.resizes     = TRUE;
            dmP->u.create.interests.updates     = TRUE;
            break;
            }
        case DIALOG_MESSAGE_UPDATE:
            {
			if (g_firstStart)
				break;
            EditElementHandle eehBUT;
		    CurveVectorPtr pCurveVec1 = CurveVector::Create(CurveVector::BOUNDARY_TYPE_Outer);
		    pCurveVec1->Add(ICurvePrimitive::CreateRectangle(100-100/2,100-100/2,100+100/2,100+100/2,0) );
		    DVec3d extrusionVec1 = DVec3d::From(0, 0, 50 );
		    DgnExtrusionDetail data1(pCurveVec1, extrusionVec1, true);//pCurveVec
		    ISolidPrimitivePtr pSolid1 = ISolidPrimitive::CreateDgnExtrusion(data1);
		    DraftingElementSchema::ToElement(eehBUT, *pSolid1, nullptr, *ACTIVEMODEL);
			
			DialogItemP diP = mdlDialog_itemGetByTypeAndId(dmP->db,RTYPE_Generic ,GENERICID_Cells , 0 );
		    updateDialog(eehBUT, dmP->db , diP);
            break;
            }
		default:
			dmP->msgUnderstood = FALSE;
            break;
		}
}

static  DialogHookInfo uHooks[]    =
{
 {HOOKID_BtnPreview,        (PFDialogHook)YuLanElement},
 {HOOKID_DlgBasic,          (PFDialogHook)DlgBasic_hookFunc},
};

extern "C" DLLEXPORT void MdlMain(int argc, WCharCP argv[])
{
	SymbolSet       *setP;      /* a ptr to a "C expression symbol set" */
    RscFileHandle    rscFileH;  /* a resource file handle */
    MSDialog        *dbP;       /* a ptr to a dialog box */

	 mdlDialog_hookPublish (sizeof(uHooks) / sizeof(DialogHookInfo), uHooks);
   
    //ǴԴļҲǴRļԴҲRжĶԻϢ
    mdlResource_openFile (&rscFileH, NULL, 0);

    // ͨıϢܱĵط һ㽫ЩȫֱᵯϢ ӰʾӰĻȡ
    setP = mdlCExpression_initializeSet (VISIBILITY_DIALOG_BOX, 0, FALSE);
	/*
	  ıһϢ壬
	  һǶһԽϢĽṹࣨUI_codeinfoȫֱHļ
	  ڶһ͵ıg_uicodeҪϢԱҪʱȡϢ
	  ǼȫֱļXXXtyp.r еǷpublishStructures(UI_codeinfo)ϢĿͿá
	  ĲϵͳmdlDialog_publishComplexVariable һʲô͵ıܸ͵Ϣ
	*/
    mdlDialog_publishComplexVariable (setP, "UI_codeinfo","g_uicode", &g_uicode);

    /* ָĶԻ򣨶ԻID֣ ɹʧܶҪʾ */
    if ( (dbP = mdlDialog_open (NULL, DIALOGID_Basic)) == NULL)// DIALOGID_TopMenu  DIALOGID_Basic
	{mdlOutput_message  ( L"򿪶Իʧܣ");return ;}
	else
	mdlOutput_message  ( L"򿪶Իɹ");


	

   // return ;
}
